#include "mpi.h"
#include <math.h>

extern double MPE_Wtime(), MPE_Ptime();

double f(a)
double a;
{
    return (4.0 / (1.0 + a*a));
}

worker(argc,argv)
int argc;
char *argv[];
{
    int done = 0, n, myid, numprocs, i, rc;
    double PI25DT = 3.141592653589793238462643;
    double mypi, pi, h, sum, x, a;
    double startwtime, endwtime;
    double startptime, endptime;

    MPI_Init(&argc,argv);
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);

    while (!done)
    {
        if (myid == 0)
        {
            printf("Enter the number of intervals: (0 quits) ");
            scanf("%d",&n);
	    startwtime = MPE_Wtime();
	    startptime = MPE_Ptime();
        }
        MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
        if (n == 0)
            done = 1;
        else
        {
            h   = 1.0 / (double) n;
            sum = 0.0;
            for (i = myid + 1; i <= n; i += numprocs)
            {
                x = h * ((double)i - 0.5);
                sum += f(x);
            }
            mypi = h * sum;

            MPI_Reduce(&mypi, &pi, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);

            if (myid == 0)
	    {
                printf("pi is approximately %.16f, Error is %.16f\n",
                       pi, fabs(pi - PI25DT));
		endwtime = MPE_Wtime();
		endptime = MPE_Ptime();
		printf("wall clock time = %f, process time = %f\n",
		       endwtime-startwtime, endptime-startptime);	       
	    }
        }
    }
    MPI_Finalize();
}

            
